// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme;

/**
    DebugPair extends Pair to provide source debugging information
*/
public class DebugPair extends Pair
{
    /**
        The filename this DebugPair was read from
    */
    public String filename;

    /**
        The line number  this DebugPair was read from
    */
    public int lineno;

    /**
        Create a DebugPair, passing the car/cdr information to our
        superclass Pair, while remembering the file information
    */
    public DebugPair (Object car,
                      Object cdr,
                      String filename,
                      int    lineno)
    {
        super (car, cdr);
        this.filename = filename;
        this.lineno   = lineno;
    }
}
