// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.expression;

import bdc.util.DynamicArray;

/**
    A DynamicArray of Expressions
*/
public class ExpressionArray extends DynamicArray
{
    /**
        PR5137

        We save a local typed pointer to the array to work around the
        fact that Netscape's verifier doesn't think object arrays are
        objects and the cast from Object[] to the more specific type
        in the array accessor would fail.

        See also SymbolArray, VariableArray, ExpressionArray
    */
    private Expression[] localArray;

    public Object[] alloc (int size)
    {
        this.localArray = new Expression[size];
        return this.localArray;
    }

    public final Expression[] array ()
    {
        return this.localArray;
    }
}
