// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;
import bdc.scheme.Stack;
import bdc.scheme.expression.Procedure3;
import bdc.scheme.expression.Procedure;

/**
    (dynamic-wind x y z)
*/
public class DynamicWind extends Procedure3
{
    public Object apply3 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];
        Object o2 = stack.array[stack.inUse-2];
        Object o3 = stack.array[stack.inUse-3];
        Procedure before = Scheme.procedure(o1, this);
        Procedure thunk  = Scheme.procedure(o2, this);
        Procedure after  = Scheme.procedure(o3, this);

        before.apply0(stack);
        try {
            return thunk.apply0(stack);
        }
        finally {
            after.apply0(stack);
        }
    }
}
