// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;
import bdc.scheme.Stack;
import bdc.scheme.exception.ParseException;
import bdc.scheme.expression.Procedure0;
import java.io.IOException;
import java.io.PushbackReader;

/**
    (peek-char) (peek-char x)
*/
public class PeekChar extends Procedure0
{

    public Object apply0 (Stack stack) throws SchemeException
    {
        try {
            stack.addElement(stack.currentInputPort);
            return apply1(stack);
        }
        finally {
            stack.inUse -= 1;
        }
    }

    public Object apply1 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];

        try {
            PushbackReader port = Scheme.pushbackReader(o1, this);
            int i = port.read();
            if (i == -1) {
                return Scheme.EOFObject;
            }
            port.unread(i);
            return new Character((char)i);
        }
        catch (IOException ioe) {
            throw new ParseException(this.toString(),
                                     0,
                                     ioe.toString());
        }
    }
}
